#include "stdafx.h"

using namespace std;

#include <map>
#include <iostream>

struct MyType { int _a; MyType(int value = 0) { _a = value; } };

template <typename _Key, typename _Value>
class MapTS
{
    typedef typename remove_pointer<_Value>::type _StructValue;
    typedef typename map<_Key, _Value>::const_iterator _MapIterator;

public:
    MapTS() { }

    ~MapTS()
    {
        dispose();
    }

    template<typename T = _Value>
    void dispose(typename enable_if< is_pointer<T>::value, T >::type value = nullptr)
    {
        for (_MapIterator it = m_map.begin(); it != m_map.end(); ++it)
        {
            if (it->second != nullptr)
            {
                delete it->second;
            }
        }
    }

    template<typename T = _Value>
    void dispose(typename enable_if< !is_pointer<T>::value, T >::type value = _Value())
    {
    }

    template<typename T = _Value>
    void SetNew(_Key key, typename enable_if< is_pointer<T>::value, T >::type value = nullptr)
    {
        _StructValue *v = new _StructValue();
        m_map.insert(pair<_Key, _Value>(key, v));
    }

    template<typename T = _Value>
    void SetNew(_Key key, typename enable_if< !is_pointer<T>::value, T >::type value = _Value())
    {
        m_map.insert(pair<_Key, _Value>(key, _Value()));
    }

    void Add(_Key key, _Value value)
    {
        map<_Key, _Value>::iterator it = m_map.find(key);
        if (it == m_map.end())
        {
            m_map.insert(pair<_Key, _Value>(key, value));
        }
        else
        {
            it->second = value;
        }
    }

private:
    map<_Key, _Value> m_map;
};

int main()
{
    MapTS<int, MyType> m1;
    m1.SetNew(5);

    MyType t1(100);
    m1.Add(5, t1);

    MapTS<int, MyType *> m2;
    m2.SetNew(6);

    MyType *t2 = new MyType();
    m2.Add(6, t2);
    
    return 0;
}

